=== debian/changelog ===
sdrangel (4.14.14-1) unstable; urgency=medium

   * Add 10 MHz digit to wideband channel plugins. Implements #531
   * Initialize m_audioSampleRate in constructors where missing. Fixes #554
   * ATVdemod: AM and horizontal sync fixes. Implements #459

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 01 Jul 2020 18:02:33 +0200

sdrangel (4.14.13-1) unstable; urgency=medium

   * Remote input: adjust buffer size depending on sample rate. Implements #534

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sun, 28 Jun 2020 08:32:53 +0200

sdrangel (4.14.12-1) unstable; urgency=medium

   * RTL-SDR: Bias tee support. Implements #533
   * Frequency tracker: added tracking delta frequency in API report. Implements #550
   * Local sink: added decoupling FIFO. Implements #549

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 27 Jun 2020 08:50:27 +0200

sdrangel (4.14.11-1) unstable; urgency=medium

   * I/Q swap option on transverter. Implements #493

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 24 Jun 2020 01:45:23 +0200

sdrangel (4.14.10-1) unstable; urgency=medium

   * Fixed Soapy SDR find module. Implements issue #519
   * Added SWSCALE to the list of required FFMpeg modules. Implements issue #437
   * Channel analyzer: fixed scope vis feed regression. Fixes issue #547
   * Sepectrum GUI: use spin boxes for spectrum range. Implements issue #546

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 20 Jun 2020 04:12:35 +0200

sdrangel (4.14.9-1) unstable; urgency=medium

   * DSD demod: implemented DMR basic privacy (dsdcc 1.8.7)

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Mon, 15 Jun 2020 19:03:39 +0200

sdrangel (4.14.8-1) unstable; urgency=medium

   * RTP audio: fixed codec setting when usinf REST API. Fixes #526

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 23 May 2020 23:01:15 +0200

sdrangel (4.14.7-1) unstable; urgency=medium

   * PlutoSDR: fixed handling of open device status. Fixes issue #510
   * Prevent use of not existent devices. Fixes issue #510 partially
   * Main GUI app: moved app creation after setting attributes. Fixes #522
   * AudioDeviceManager: make sure a negative or null sample rate is never returned

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 20 May 2020 11:35:17 +0200

sdrangel (4.14.6-1) unstable; urgency=medium

   * Spectrum analyzer code reorganization
   * FFTFactory: add mutex for thread safety. Implements issue #514
   * SpectrumVis: release previous FFT engine allocation from FFT factory only if allocated once. Fixes issue #515

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 16 May 2020 06:35:17 +0200

sdrangel (4.14.5-1) unstable; urgency=medium

   * DATV demod: applied some recent changes in leansdr
   * Fixed incorrect frequency display when transverter is engaged. Fixes issue #509
   * ATV mod: Ubuntu 20.04 OpenCV code compatibility. Fixes issue #511
   * Fixed some warnings from Mac ports compilation (2)

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Tue, 28 Apr 2020 03:35:17 +0200

sdrangel (4.14.4-1) unstable; urgency=medium

  * XTRX: REST API: fixed wrong setting object
  * XTRX: fixed sample rate setting
  * XTRX: reduce block size to 4096 bytes
  * LimeSDR: revised labels and tooltips for antenna select. Fixes issue #506
  * LimeSDR: GUI: flip SR and Hw/Sw decimation or interpolation displays
  * AM demod: fixed initialization of squelch counter. Fixes issue #502
  * Make OpenCV optional in main cmake file. Fixes #503
  * Fixed some warnings from Mac ports compilation
  * Compile with c++11 comaptible version of CM256cc

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 20 Apr 2020 05:35:17 +0200

sdrangel (4.14.3-1) unstable; urgency=medium

  * Sample sources GUI file record: right click to choose file. Implements #483.
  * BladeRF2: REST API: implemented actions (was missing)

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 01 Apr 2020 19:05:22 +0200

sdrangel (4.14.2-1) unstable; urgency=medium

  * Removed cm256cc dependency and therefore remote plugins for Mac OS. Fixes #492
  * REST API: removed useless SWGDevicesetApi files. Fixes #491
  * BFM demod: added initialization of message to GUI address. Fixes #488

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sat, 28 Mar 2020 19:05:22 +0100

sdrangel (4.14.1-1) unstable; urgency=medium

  * FFT factory with option to use fftwf wisdom file. Impements issue #482.

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Mon, 16 Mar 2020 21:01:22 +0100

sdrangel (4.14.0-1) unstable; urgency=medium

  * REST API device and channel actions. Implements #485.
  * LimeRFE USB: added cellular band 3 and improved API documentation

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 11 Mar 2020 15:14:22 +0100

sdrangel (4.13.2-1) unstable; urgency=medium

  * CI/CD implmentation with Appveyor

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Sun, 01 Mar 2020 05:14:22 +0100

sdrangel (4.13.1-1) unstable; urgency=medium

  * LimeRFE USB support: fixed attenuator and AM/FM notch settings
  * FileSource: fixed various issues with settings with GUI and REST API. Fixes issue #481
  * FFT: added Kaiser window with alpha factor at pi
  * Removed librtlsdr in the list of dependencies in Debian install
  * SoapySDR: fixed FindSoapySDR.cmake
  * SoapySDR: Fix case-sensitive package check

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 26 Feb 2020 22:14:22 +0100

sdrangel (4.13.0-1) unstable; urgency=medium

  * LimeRFE USB support

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 22 Jan 2020 12:14:22 +0100

sdrangel (4.12.5-1) unstable; urgency=medium

  * Removed MIMO plugins and related code

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Wed, 01 Jan 2020 06:14:22 +0100

sdrangel (4.12.4-1) unstable; urgency=medium

  * Debian build: moved librtlsdr to external libraries

 -- Edouard Griffiths, F4EXB <f4exb06@gmail.com>  Tue, 17 Dec 2019 19:14:22 +0100

sdrangel (4.12.3-1) unstable; urgency=medium


